{
  Susie Zip extract plugin
  2003/4-

  
    ProgressCallback01002񂵂Ă΂Ȃ
    Ήmethodstoreddeflate

  2003-04-29
    GetArchiveInfo: t@CSizeOf(EndOfCentaralDir)+64KB܂Ńwb_T
    GetFileInfo: FileInfo.pathݒ肵ĂȂ̂ŏC
  2003-04-26
    GetArchiveInfo: susieŃfBNgA[JCu
    WJłȂ̂ŏC
}

library amzip;

uses Windows,
  spi_api, unzip, ZLib;

{$E .spi}

const
  Version = '0.2';
  PluginInfo: array[0..3] of PChar = (
    '00AM',             // Plug-in APIo[W
    'ZIP extract library ver'+Version+' (C)Ferdia',
                        // Plug-inAo[Wy copyright
    '*.zip',            // \IȊgq ('*.JPG' '*.JPG;*.JPEG' Ȃ)
    'ZIP file(*.zip)'   // t@C`
  );

function GetPluginInfo(infono: Integer; buf: PChar; buflen: Integer): Integer; stdcall; forward;
function IsSupported(filename: LPSTR; dw: DWORD): Integer; stdcall; forward;
function GetArchiveInfo(buf: LPSTR; len: Longint; flag: unsigned_int;
  var hinf: HLOCAL): Integer; stdcall; forward;
function GetFileInfo(buf: LPSTR; len: Longint; filename: LPSTR; flag: unsigned_int;
  var Info: TFileInfo): Integer; stdcall; forward;
function GetFile(src: LPSTR; len: Longint; dest: LPSTR; flag: unsigned_int;
  ProgressCallback: TProgressCallback; lData: Longint): Integer; stdcall; forward;
//function ConfigurationDlg(Parent: HWND; fnc: Integer): Integer; stdcall;

exports
  //ConfigurationDlg,
  GetPluginInfo,
  IsSupported,
  GetArchiveInfo,
  GetFileInfo,
  GetFile;

function DosTimeTotime_t(DosDate, DosTime: Word): Integer;
var
//  Day, Month, Year, Sec, Min, Hour: Integer;
  st: TSystemTime;
  ft, ft2: TFileTime;
begin
  {
  Day := DosDate and $1F;
  Month := DosDate shr 5 and $F;
  Year := DosDate shr 9 and $7F + 1980;
  Sec := DosTime and $1F shl 1;
  Min := DosTime shr 5 and $3F;
  Hour := DosTime shr 11 and $1F;
  }
  st.wYear := 1970;
  st.wMonth := 1;
  st.wDay := 1;
  st.wHour := 0;
  st.wMinute := 0;
  st.wSecond := 0;
  st.wMilliseconds := 0;
  SystemTimeToFileTime(st, ft);
  DosDateTimeToFileTime(DOSDate, DOSTime, ft2);
  Result := Trunc((Comp(ft2) - Comp(ft)) / 10000000.0);
end;

// ΃pX\LFileNamepathfilenameɕFileInfoɃZbg
// ł/\ɕϊ(ϊȂsusie摜WJłȂ)
procedure SetFilePath(FName: string; var FileInfo: TFileInfo);
var
  i, idx: Integer;
begin
  i := 1;
  idx := 0;
  while i <= Length(FName) do
  begin
    if IsDBCSLeadByte(Byte(FName[i])) then
      Inc(i)
    else if (FName[i] = '\') or (FName[i] = '/') then
    begin
      FName[i] := '\';
      idx := i;
    end;
    Inc(i);
  end;
  if idx > 0 then
    Move(FName[1], FileInfo.path, idx);
  if idx < Length(FName) then
    Move(FName[idx+1], FileInfo.filename, Length(FName)-idx+1);
end;

procedure SetFileInfo(var FileInfo: TFileInfo; HeaderPos: Integer;
  const Header: TZipFileHeader; const FName: string);
begin
  with FileInfo do
  begin
    case Header.Method of
       0: method := 'Stored';
       Z_DEFLATED: method := 'Deflate';
    end;
    position := HeaderPos;
    compsize := Header.CompSize;
    filesize := Header.UnCompSize;
    timestamp := DosTimeTotime_t(Header.FileMDate, Header.FileMTime);
    SetFilePath(FName, FileInfo);
    CRC := Header.Crc;
  end;
end;

function GetPluginInfo(InfoNo: Integer; Buf: PChar; BufLen: Integer): Integer; stdcall;
begin
  Result := 0;
  if (InfoNo >= 0) and (InfoNo <= High(PluginInfo)) then
  begin
    lstrcpyn(Buf, PluginInfo[InfoNo], BufLen);
    Result := lstrlen(Buf);
  end;
end;

function IsSupported(filename: LPSTR; dw: DWORD): Integer; stdcall;
var
  ReadBytes : DWORD;
  Sign: array[0..3] of Char;
begin
  Result := 0;

  if (dw and $FFFF0000) = 0 then
  begin
    // DW̓t@Cnh
    if ReadFile(dw, Sign, SizeOf(Sign), ReadBytes, nil) = False then
      Exit;
  end else
    // DW̓obt@ւ̃|C^
    Move(Pointer(dw)^, Sign, SizeOf(Sign));

  if Sign = ZIP_FILE_HEADER_SIGN then
    Result := 1;
end;

// t@CT̂len͖
function GetArchiveInfo(buf: LPSTR; len: Longint; flag: unsigned_int;
  var hinf: HLOCAL): Integer; stdcall;
var
  ReadBytes : DWORD;
  hf : THandle;
  PInfo : PFileInfo;
  FileCount : Integer;
  FName: string;
  Sign: array[0..3] of Char;
  CDir: TCentralDirectory;
  EndCDir: TEndOfCentralDirectory;
  TopCDirPos: Integer;
  Ofs: Integer;
  BackByte: Integer;
//  BackBuf: array[0..1023] of Char;
  BackBuf: string;
  idx: Integer;
begin
  //͖Ή
  if (flag and 7) <> 0 then
  begin
    Result := SPI_ERROR_NOT_IMPLEMENTED;
    Exit;
  end;

  //t@CI[v buf̓t@C
  hf := CreateFile(Buf, GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING,
    FILE_ATTRIBUTE_NORMAL, 0);
  if (hf = INVALID_HANDLE_VALUE) then
  begin
    Result := SPI_ERROR_FILE_READ;
    Exit;
  end;

  hinf := LocalAlloc(LHND, SizeOf(TFileInfo));
  if hinf = 0 then
  begin
    CloseHandle(hf);
    Result := SPI_ERROR_ALLOCATE_MEMORY;
    Exit;
  end;

  SetFilePointer(hf, -SizeOf(Sign)-SizeOf(EndCDir), nil, FILE_END);
  ReadFile(hf, Sign, SizeOf(Sign), ReadBytes, nil);
  if ReadBytes < SizeOf(Sign) then
  begin
    CloseHandle(hf);
    LocalFree(hinf);
    Result := SPI_ERROR_BROKEN_DATA;
    Exit;
  end;
  if Sign <> ZIP_END_CENTRALDIR_HEADER_SIGN then
  begin
    // End of Cental DirT(64KB܂ł̂ڂ)
    BackByte := 0;
    SetLength(BackBuf, 1024);
    while True do
    begin
      SetFilePointer(hf, -Length(BackBuf), nil, FILE_CURRENT);
      FillChar(BackBuf[1], Length(BackBuf), 0);
      ReadFile(hf, BackBuf[1], Length(BackBuf), ReadBytes, nil);
      Inc(BackByte, ReadBytes);
      idx := Pos(ZIP_END_CENTRALDIR_HEADER_SIGN, BackBuf);
      if idx > 0 then
      begin
        SetFilePointer(hf, -ReadBytes+idx-1+SizeOf(Sign), nil, FILE_CURRENT);
        Break;
      end;
      if (ReadBytes < Length(BackBuf)) or (BackByte >= 65536) then
      begin
        CloseHandle(hf);
        LocalFree(hinf);
        Result := SPI_ERROR_BROKEN_DATA;
        Exit;
      end;
      // ESignatureꍇl4bytesԂ点ēǂ
      SetFilePointer(hf, -Length(BackBuf)+SizeOf(Sign), nil, FILE_CURRENT);
    end;
  end;

  ReadFile(hf, EndCDir, SizeOf(EndCDir), ReadBytes, nil);
  TopCDirPos := SetFilePointer(hf, -SizeOf(Sign)-SizeOf(EndCDir)-EndCDir.SizeCentralDir, nil, FILE_CURRENT);
  // EndCDirɋL^ĂCentralDir̃TCYvZCentralDirJnʒu
  // EndCDirɋL^ĂJnʒu̍Local FilẽItZbgɑ
  // (ɃS~Ăꍇ̑΍)
  // (ԂunzipƓ)
  Ofs := TopCDirPos - EndCDir.OffsetStartCentralDir;

  FileCount := 0;
  while True do
  begin
    ReadFile(hf, Sign, SizeOf(Sign), ReadBytes, nil);
    if ReadBytes < SizeOf(Sign) then
      Break;
    if Sign <> ZIP_CENTRALDIR_HEADER_SIGN then
      Break;
    ReadFile(hf, CDir, SizeOf(CDir), ReadBytes, nil);
    Inc(FileCount);
    hinf := LocalRealloc(hinf, SizeOf(TFileInfo)*(FileCount+1), LMEM_MOVEABLE or LMEM_ZEROINIT);
    if hinf = 0 then
    begin
      CloseHandle(hf);
      LocalFree(hinf);
      Result := SPI_ERROR_ALLOCATE_MEMORY;
      Exit;
    end;
    SetLength(FName, CDir.FileNameLen);
    ReadFile(hf, FName[1], CDir.FileNameLen, ReadBytes, nil);
    PInfo := LocalLock(hinf);
    Inc(PInfo, FileCount-1);
    with PInfo^ do
    begin
      case CDir.Method of
        0: method := 'Stored';
        Z_DEFLATED: method := 'Deflate';
      end;
      position := CDir.LocalHeaderOffset + Ofs;
      compsize := CDir.CompSize;
      filesize := CDir.UnCompSize;
      timestamp := DosTimeTotime_t(CDir.FileMDate, CDir.FileMTime);
      SetFilePath(FName, PInfo^);
      CRC := CDir.Crc;
    end;
    LocalUnLock(hinf);
    SetFilePointer(hf, CDir.ExtraFieldLen+CDir.FileCommentLen, nil, FILE_CURRENT);
  end;


  {
  // CentalDirg킸ɐ擪To[W
  FileCount := 0;
  while True do
  begin
    HeaderPos := SetFilePointer(hf, 0, nil, FILE_CURRENT);
    ReadFile(hf, Header, SizeOf(Header), ReadBytes, nil);
    if ReadBytes < SizeOf(Header) then
      Break;
    if Header.Sign <> ZIP_FILE_HEADER_SIGN then
      Break;
    Inc(FileCount);
    InfoHandle := LocalRealloc(InfoHandle, SizeOf(TFileInfo)*(FileCount+1), LMEM_MOVEABLE or LMEM_ZEROINIT);
    if InfoHandle = HLOCAL(nil) then
    begin
      CloseHandle(hf);
      LocalFree(InfoHandle);
      Result := SpiNoMemory;
      Exit;
    end;
    SetLength(FName, Header.FileNameLen);
    ReadFile(hf, FName[1], Header.FileNameLen, ReadBytes, nil);
    PInfo := LocalLock(InfoHandle);
    Inc(PInfo, FileCount-1);
    SetFileInfo(PInfo^, HeaderPos, Header, FName);
    LocalUnLock(InfoHandle);
    SetFilePointer(hf, Header.ExtraFieldLen+Header.CompSize, nil, FILE_CURRENT);
  end;
  }
  CloseHandle(hf);
  Result := SPI_ERROR_SUCCESS;
end;

function GetFileInfo(buf: LPSTR; len: Longint; filename: LPSTR; flag: unsigned_int;
  var Info: TFileInfo): Integer; stdcall;
var
  ReadBytes : DWORD;
  hf : THandle;
  Header: TZipFileHeader;
  FName: string;
  Sign: array[0..3] of Char;
begin
  //͖Ή
  if (flag and 7) <> 0 then
  begin
    Result := SPI_ERROR_NOT_IMPLEMENTED;
    Exit;
  end;
  //t@CI[v buf̓t@C
  hf := CreateFile(Buf, GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING,
    FILE_ATTRIBUTE_NORMAL, 0);
  if (hf = INVALID_HANDLE_VALUE) then
  begin
    Result := SPI_ERROR_FILE_READ;
    Exit;
  end;

  // ItZbgV[N
  SetFilePointer(hf, len, nil, FILE_BEGIN);

  ReadFile(hf, Sign, SizeOf(Sign), ReadBytes, nil);
  if (Sign <> ZIP_FILE_HEADER_SIGN) or (ReadBytes < SizeOf(Sign)) then
  begin
    CloseHandle(hf);
    Result := SPI_ERROR_BROKEN_DATA;
    Exit;
  end;

  ReadFile(hf, Header, SizeOf(Header), ReadBytes, nil);
  if ReadBytes < SizeOf(Header) then
  begin
    CloseHandle(hf);
    Result := SPI_ERROR_BROKEN_DATA;
    Exit;
  end;

  SetLength(FName, Header.FileNameLen);
  ReadFile(hf, FName[1], Header.FileNameLen, ReadBytes, nil);
  SetFileInfo(Info, Len, Header, FName);
  CloseHandle(hf);
  Result := SPI_ERROR_SUCCESS;
end;

// A[JCũt@C擾
function GetFile(src: LPSTR; len: Longint; dest: LPSTR; flag: unsigned_int;
  ProgressCallback: TProgressCallback; lData: Longint): Integer; stdcall;
var
  Header: TZipFileHeader;
  Sign: array[0..3] of Char;
  ReadBytes : DWORD;
  hf : THandle;
  PHMem : PHandle;//^HLOCAL;
  DataBuf : PByte;
  InBuf, OutBuf: string;
  r: Integer;
begin
  if Assigned(ProgressCallBack) then
  begin
    if ProgressCallBack(0, 100, lData) <> 0 then
    begin
      Result := SPI_ERROR_CANCEL_EXPAND;
      Exit;
    end;
  end;

  //t@Co͖Ή
  if (flag and $700) = 0 then
  begin
    Result := SPI_ERROR_NOT_IMPLEMENTED;
    Exit;
  end;
  //͖Ή
  if (flag and 7) <> 0 then
  begin
    Result := SPI_ERROR_NOT_IMPLEMENTED;
    Exit;
  end;

  // Src̓t@C
  hf := CreateFile(Src, GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
  if (hf = INVALID_HANDLE_VALUE) then
  begin
    Result := SPI_ERROR_FILE_READ;
    Exit;
  end;

  // ItZbgV[N
  SetFilePointer(hf, Len, nil, FILE_BEGIN);
  // do error check!

  ReadFile(hf, Sign, SizeOf(Sign), ReadBytes, nil);
  if (Sign <> ZIP_FILE_HEADER_SIGN) or (ReadBytes < SizeOf(Sign)) then
  begin
    CloseHandle(hf);
    Result := SPI_ERROR_BROKEN_DATA;
    Exit;
  end;

  ReadFile(hf, Header, SizeOf(Header), ReadBytes, nil);
  if ReadBytes < SizeOf(Header) then
  begin
    CloseHandle(hf);
    Result := SPI_ERROR_BROKEN_DATA;
    Exit;
  end;

  PHMem := PHandle(Dest);
  PHMem^ := LocalAlloc(LMEM_MOVEABLE, Header.UnCompSize);
  if PHMem^ = HLOCAL(nil) then
  begin
    CloseHandle(hf);
    Result := SPI_ERROR_ALLOCATE_MEMORY;
    Exit;
  end;
  // check error?
  SetFilePointer(hf, Header.FileNameLen + Header.ExtraFieldLen, nil, FILE_CURRENT);
  SetLength(InBuf, Header.CompSize);
  ReadFile(hf, InBuf[1], Header.CompSize, ReadBytes, nil);
  CloseHandle(hf);
  DataBuf := LocalLock(PHMem^);
  if Header.Method = 0 then
    Move(InBuf[1], DataBuf^, Header.UnCompSize) //ʃRs[
  else begin
    r := Decompress(InBuf, OutBuf, Header.UnCompSize);
    if r < Z_OK then
    begin
      LocalUnLock(PHMem^);
      Result := SPI_ERROR_BROKEN_DATA;
      Exit;
    end;
    Move(OutBuf[1], DataBuf^, Header.UnCompSize);
  end;
  LocalUnLock(PHMem^);
  if Assigned(ProgressCallBack) then
  begin
    if ProgressCallBack(100, 100, lData) <> 0 then
    begin
      Result := SPI_ERROR_CANCEL_EXPAND;
      Exit;
    end;
  end;
  Result := SPI_ERROR_SUCCESS;
end;

// Plug-inݒ_CAO\
{
function ConfigurationDlg(Parent: HWND; fnc: Integer): Integer; stdcall;
begin
  Result := SPI_ERROR_NOT_IMPLEMENTED;
end;
}
begin
 IsMultiThread := True;
end.

